## Installation of Node.js and NPM

[Node.js](https://nodejs.org/) is an open-source, cross-platform [runtime environment](https://en.wikipedia.org/wiki/Runtime_system), It allows developers to run JavaScript on the server side, creating web applications that can generate dynamic content. Node.js runs on the [V8 JavaScript Engine](<https://en.wikipedia.org/wiki/V8_(JavaScript_engine)>) and executes JavaScript code outside a web browser. Node.js uses an event-driven, non-blocking I/O model that makes it lightweight and efficient, perfect for data-intensive real-time applications that run across distributed devices.

[NPM](https://www.npmjs.com/) is the package module which helps javascript developers install dependencies effectively. It stands for Node Package Manager and it's a command-line tool that comes with Node.js that allows developers to install and manage a wide variety of third-party JavaScript libraries and packages for use in their own projects. It also makes it easy for developers to share and reuse code by publishing their own packages to the NPM registry, which is a public repository of packages of open-source code. NPM is an essential part of the Node.js ecosystem and is widely used by developers to streamline their workflow and build powerful applications. NPM is the default package manager for Node.js.

To install Node.js, you will need to download the appropriate installer for your operating system from the official Node.js website. Once the download is complete, you can run the installer and follow the on-screen instructions to complete the installation.

Here is a brief overview of the steps you will need to follow:

1. Go to the official [Node.js](https://nodejs.org/) website.
2. Click on the `Download` button to download the LTS version of Node.js.
3. Once the download is complete, run the installer and follow the on-screen instructions to complete the installation.

Keep in mind that the exact steps may vary depending on your operating system, so you may need to consult the official Node.js documentation for more detailed instructions.

Once the installation is complete, you can verify that Node.js has been successfully installed by opening a command prompt or terminal window and typing:

```bash
node -v
```

and test npm by printing its version using command:

```bash
npm -v
```

You should see the Node and NPM version you have installed.

## Install Visual Studio Code

Visual Studio Code (VS Code) is a lightweight but powerful source code editor. Getting up and running with Visual Studio Code is quick and easy. It is available for Windows, macOS, and Linux operating systems.

To install Visual Studio Code, you will need to download the appropriate installer for your operating system from the official Visual Studio Code website. Once the download is complete, you can run the installer and follow the on-screen instructions to complete the installation.

Here is a brief overview of the steps you will need to follow:

1. Go to the official [Visual Studio Code](https://code.visualstudio.com/) website.
2. Click on the `Download` button to download the latest version.
3. Once the download is complete, run the installer and follow the on-screen instructions to complete the installation.

Keep in mind that the exact steps may vary depending on your operating
system, so you may need to consult the official Visual Studio Code
documentation for more detailed instructions:

- [Windows](https://code.visualstudio.com/docs/setup/windows)
- [macOS](https://code.visualstudio.com/docs/setup/mac)
- [Linux](https://code.visualstudio.com/docs/setup/linux)

Check out the following docs by Visual Studio Code to learn more about:

- [Terminal](https://code.visualstudio.com/docs/terminal/basics)
- [Working with JavaScript](https://code.visualstudio.com/docs/nodejs/working-with-javascript)
- [Using React in VS Code](https://code.visualstudio.com/docs/nodejs/reactjs-tutorial)

### Install Useful Visual Studio Code Extensions

Visual Studio Code [extensions](https://code.visualstudio.com/docs/nodejs/extensions) can add more features to the overall development experience. Here are
some extensions that I'm using:

- [Prettier - Code formatter](https://marketplace.visualstudio.com/items?itemName=esbenp.prettier-vscode)
- [JavaScript (ES6) code snippets](https://marketplace.visualstudio.com/items?itemName=xabikos.JavaScriptSnippets)
- [Material Icon Theme](https://marketplace.visualstudio.com/items?itemName=PKief.material-icon-theme)

## Get GitHub Account & Desktop Application

[GitHub](https://github.com/) is a cloud-based service that helps developers store source code, and
collaborate with others on a project. GitHub also track and manage
changes to the code with version control.

### Sign Up a GitHub Account

To sign up for a GitHub account, follow these steps:

1. Go to [github.com](https://github.com/signup) in your web browser.
2. Click on the `Sign up` button in the top-right corner of the page.
3. Fill out the form that appears with your personal information, including your username, email address, and password.
4. Click on the `Sign up for GitHub` button at the bottom of the form to create your account.

After you sign up for a GitHub account, you can start using the service
to host and manage your code repositories, collaborate with others on
projects, and more.

### GitHub Desktop

GitHub Desktop is a free and open-source Git client, a useful tool for
developers who want to use Git and GitHub to manage their code
repositories. It is available for Windows and MacOS, and it provides a
user-friendly graphical interface for common Git operations such as
cloning, committing, and pushing changes to a repository. To install
GitHub Desktop, follow these steps:

1. Go to the [GitHub Desktop](https://desktop.github.com/) website.
2. Click on the `Download for Mac` or `Download for Windows` button, depending on your operating system.
3. Save the installation file to your computer and run it to begin the installation process.
4. Follow the on-screen instructions to complete the installation.

After you have installed GitHub Desktop, to log in to GitHub Desktop,
follow these steps:

1. Launch GitHub Desktop on your computer.
2. In the application window, click on the `Sign in` button.
3. Enter your GitHub username and password, and then click on the `Sign in` button.
4. Click on the `Authorize` button to allow GitHub Desktop to access your
   account.

After you log in to GitHub Desktop, you can start using the application to manage your Git repositories, collaborate with others on projects, and more. You can also use GitHub Desktop to access the GitHub website, view your profile and repositories, and more.

To clone a repository on GitHub Desktop, follow these steps:

1. Click on the `File` menu and select `Clone Repository` from the drop-down menu.
2. In the `Clone a Repository` window, select the repository you have just created.
3. Click on the `Choose...` button to select a local destination for the cloned repository.
4. Click on the `Clone` button to clone the repository.

After the repository is cloned, you can access it from the local destination you specified, and you can use GitHub Desktop to manage and work with the repository. You can also push changes you make to the local repository back to the remote repository on GitHub.

import MDXLessonLayout from "@/src/components/lms/Lesson/MDXLessonLayout.tsx";
export default ({ children }) => <MDXLessonLayout>{children}</MDXLessonLayout>;
